#!/usr/bin/perl

use Test::Simple tests => 10;

use Time::Available qw(:days :fmt_interval);

#my $i = Time::Available->new( start=>'07', end=>'17:15', dayMask=>DAY_WEEKDAY, DEBUG=>1 );
my $i = Time::Available->new( start=>'17:15', end=>'07:00', dayMask=>DAY_TUESDAY);
ok( defined($i) , 'new() work');

ok( defined($i->{start}) && $i->{start} == 7*60*60, 'start time ok' );
ok( defined($i->{end}) && $i->{end} == ((17*60)+15)*60, 'end time ok' );

my $t = 1 * 24;	# 1d
$t += 11;	# 11 hr
$t *= 60;
$t += 11;	# 11 min
$t *= 60;
$t += 11;	# 11 sec

ok( fmt_interval($t) eq '1d 11:11:11', 'fmt_interval output ok');

# 20000 = Thu Jan  1 06:33:20 1970
# 30000 = Thu Jan  1 09:20:00 1970
# 50000 = Thu Jan  1 14:53:20 1970
# 60000 = Thu Jan  1 17:40:00 1970

# test this timespan (07:00-17:15) with above values

ok($i->uptime(20000)==36900,'ok');
ok($i->uptime(30000)==28500,'ok');
ok($i->uptime(50000)==8500,'ok');
ok($i->uptime(60000)==0,'ok');

undef $i;

# create and test timespan which spans over midnight

$i = Time::Available->new( start=>'17:15', end=>'07:00', dayMask=>DAY_TUESDAY);
ok( defined($i->{start}) && $i->{start} == ((17*60)+15)*60, 'end time ok' );
ok( defined($i->{end}) && $i->{end} == 7*60*60, 'start time ok' );

$t=time();print STDERR " uptime ( $t ",$i->uptime($t)," ) ",scalar localtime $t,": ",fmt_interval($i->uptime($t))," (",$i->uptime($t),")\n";
$t=20000; print STDERR " uptime ( $t ",$i->uptime($t)," ) ",scalar localtime $t,": ",fmt_interval($i->uptime($t))," (",$i->uptime($t),")\n";
$t=30000; print STDERR " uptime ( $t ",$i->uptime($t)," ) ",scalar localtime $t,": ",fmt_interval($i->uptime($t))," (",$i->uptime($t),")\n";
$t=50000; print STDERR " uptime ( $t ",$i->uptime($t)," ) ",scalar localtime $t,": ",fmt_interval($i->uptime($t))," (",$i->uptime($t),")\n";
$t=60000; print STDERR " uptime ( $t ",$i->uptime($t)," ) ",scalar localtime $t,": ",fmt_interval($i->uptime($t))," (",$i->uptime($t),")\n";

